=== modified file 'source/displayModel.py'
--- source/displayModel.py	2011-09-18 04:22:21 +0000
+++ source/displayModel.py	2011-11-21 10:17:40 +0000
@@ -16,6 +16,9 @@
 #: Objects that have registered for text change notifications.
 _textChangeNotificationObjs=[]
 
+COLOR_HIGHLIGHT=colors.RGB.fromCOLORREF(winUser.user32.GetSysColor(13))
+COLOR_HIGHLIGHTTEXT=colors.RGB.fromCOLORREF(winUser.user32.GetSysColor(14))
+
 def initialize():
 	global _getWindowTextInRect,_requestTextChangeNotificationsForWindow
 	_getWindowTextInRect=CFUNCTYPE(c_long,c_long,c_long,c_int,c_int,c_int,c_int,c_int,c_int,c_bool,POINTER(BSTR),POINTER(BSTR))(('displayModel_getWindowTextInRect',NVDAHelper.localLib),((1,),(1,),(1,),(1,),(1,),(1,),(1,),(1,),(1,),(2,),(2,)))
@@ -179,6 +182,27 @@
 	def _get_clipboardText(self):
 		return super(DisplayModelTextInfo,self).clipboardText.replace('\0',' ')
 
+	def _getHighlightOffsets(self,color=None,backgroundColor=None):
+		if color is None: color=COLOR_HIGHLIGHTTEXT
+		if backgroundColor is None: backgroundColor=COLOR_HIGHLIGHT
+		offset=0
+		startOffset=endOffset=-1
+		info=self.__class__(self.obj,textInfos.POSITION_ALL)
+		fields=info.getTextWithFields()
+		for field in fields:
+			if isinstance(field,basestring): offset+=len(field)
+			elif isinstance(field,textInfos.FieldCommand) and field.command=="formatChange":
+				try:
+					if field.field["color"]==color and field.field["background-color"]==backgroundColor:
+						if startOffset==-1: startOffset=offset
+					else:
+						if startOffset!=-1 and endOffset==-1: endOffset=offset
+				except: pass
+		return (startOffset,endOffset)
+
+	def _getHighlightedText(self,color=None,backgroundColor=None):
+		return self._getTextRange(*self._getHighlightOffsets(color,backgroundColor))
+
 class EditableTextDisplayModelTextInfo(DisplayModelTextInfo):
 
 	minHorizontalWhitespace=1

